% **************************************************************************** %
\section{Introduction}
% **************************************************************************** %


% **************************************************************************** %
\begin{frame}[c]\frametitle{Goal and Context}
		Goal of the thesis:
		\begin{itemize}
			\item Write a comprehensive introduction of the density operator in eigenvalue problems, and apply the  interpolation on manifolds to density operator
		\end{itemize}
		% Research background and context:
		% \begin{itemize}
		% 	\item Eigenvalue computations in mathematical quantum chemistry
		% 	\item Differential geometry, especially Stiefel and Grassmann manifolds
		% 	\item Laplace operator and interpolation
		% \end{itemize}
\end{frame}
% **************************************************************************** %


% **************************************************************************** %
\section{Density Operator}
\begin{frame}[t, shrink]\frametitle{Introduction Quantum Chemistry}

	\begin{itemize}
		\item One of the main goals is to find the lowest energy state → ground state energy 
		\item Physical observables  are given by the eigenvalues of self-adjoint operators 
	\end{itemize}
	
	\vspace*{2mm}
	\begin{align}
		H \psi &= E \psi   \\
		H &= T + V
	\end{align}
	\vspace*{2mm}

	\begin{itemize}
		\item $\psi$ is the so called wavefunction and describes the state of the quantum system
	\end{itemize}

	\begin{theorem}[Ground State Energy]~\\    
		\begin{align}
			E_0 = \inf \{ E(\psi) = \int_{ \mathbb{R}^{3N}} \psi^* H \psi \ dx_1, \dots, dx_N \ , \psi \in L^2(\mathbb{R}^{3N},\mathbb{C}), \ \| \psi \|_{L^2} =1 \}
		\end{align}
	\end{theorem} 

\end{frame}
% **************************************************************************** %

% **************************************************************************** %
\begin{frame}[t]\frametitle{Introduction Quantum Chemistry}

	\vspace*{10mm}
	The ground state problem is hard because of the high dimensionality of the wavefunction.
	\vspace*{5mm}

	\textbf{Simplification:}
	\begin{itemize}
		\item Focus on individual electron orbitals $\{\phi_1, \dots, \phi_N \}$ ($\phi_i \in L^2(\mathbb{R}^{3},\mathbb{C}),\ \phi_i \phi_j = \delta_{i,j}$)
	\end{itemize}
	\vspace*{5mm}

	However, the price we pay is the loss of correlation and exchange energy.
	\begin{itemize}
		\item Electronic correlation is the interaction between electrons 
		\item Exchange energy means that electrons are not allowed to close to each other
	\end{itemize}




\end{frame}
% **************************************************************************** %


% **************************************************************************** %
\begin{frame}[t,fragile,shrink]\frametitle{Density Operator}
	\begin{block}{Density operator}
		The density operator associated with state $\psi \in L^2$ with the basis $\{\phi_i\}_{i=1}^N$ is defined as:
		\begin{equation}
			\text{D} =\sum_{i=1}^{N} \phi_i (\phi_i, \cdot )_{L^2} .
		\end{equation}
	\end{block}

	  \begin{center}
		  \begin{minipage}[c]{0.8\linewidth}
			\begin{itemize}
				\item $\textnormal{Tr}(\text{D}) = N$
				\item $\text{D}^2 = \text{D}$
				\item $\text{D}^* = \text{D}$
			\end{itemize} 
		  \end{minipage}
	\end{center}

	\begin{block}{Invariant under Unitary Transformations}
		The density operator is invariant under unitary transformation. Let U be a unitary operator, $\text{D}$ a density operator constructed with the basis $\{\phi_i\}_{i=1}^N$ and $\widetilde{\text{D}}$ constructed with $\{\theta_i\}_{i=1}^N$, where $\theta_i = \phi_i U$. Then the following is true:
		\begin{align*}
			\text{D} = \widetilde{\text{D}} .
		\end{align*}
	\end{block} 

\end{frame}
% **************************************************************************** %

% **************************************************************************** %
\begin{frame}[t,fragile]\frametitle{Density Operator}

	Instead of an energy functional, the expectation value can be computed by :
		\begin{align}
			\text{Tr}(A\text{D}) = \sum_{i=1}^N (\phi_i,A \phi_i)_{L^2}
		\end{align}

	\begin{block}{Ground State Energy Density Operator}
		\begin{align}
			E_0 = \inf \{ E(D) = \textnormal{Tr}(\text{h} \text{D}) + \text{Tr}(G(\text{D}) \text{D})),  \text{D} = \text{D}^2 = \text{D}^* , \textnormal{Tr}(\text{D})=\text{N}  \}
		\end{align}

		\begin{itemize}
			\item h is the core Hamilton, which corresponds to linear contributions $h = -\Delta + V$
			\item $G(\text{D})$ correspond to the nonlinear contributions like exchange and correlation energy
		\end{itemize}
	\end{block} 

\end{frame}
% **************************************************************************** %

% **************************************************************************** %
\begin{frame}[t]\frametitle{Motivation Grassmann Manifold}
	\vspace*{30mm}
		\centering
		\textbf{Density operator do not form a vector space !}   \\
		Density operator live on the Grassmann manifold, therefore \\
		in order to build and analyze algorithms, we need knowledge of the Grassmann manifold
\end{frame}
% **************************************************************************** %


% **************************************************************************** %
\section{Differential Geometry}
\begin{frame}[t]\frametitle{Riemann Manifold}

	\begin{block}{Riemann Manifold}
		A manifold $\mathcal{M}$ is called Riemannian manifold if it is equipped with a smooth varying inner product called Riemann metric:
		\begin{align}
				g_x(\xi ,\zeta), \quad  \quad \xi, \zeta \in T_x\mathcal{M} .
		\end{align}
	\end{block}

	\begin{block}{Tangent Space}
		Let $\mathcal{M}$ be a submanifold of $\mathbb{R}^{n \times p}$. The tangent space of $\mathcal{M}$ at a point $p \in \mathcal{M}$, in symbols $T_p \mathcal{M}$, is the space of velocity vectors of differentiable curves $c:t \mapsto c(t)$ passing through $p$, i.e.,
		\begin{align}
				T_p \mathcal{M} = \{ \dot c(t_0) \ | \ c: J \mapsto \mathcal{M}, \ c(t_0) = p \} ,
		\end{align}
		where $J \subseteq \mathbb{R}$ is an arbitrary small open interval with $t_0 \in J$.  
	\end{block}

\end{frame}
% **************************************************************************** %

% **************************************************************************** %
\begin{frame}[c]\frametitle{Stiefel Manifold}

	\begin{block}{Stiefel Manifold}
		The Stiefel manifold $St(n,p) \subset \mathbb{R}^{n \times p}$ can be thought of as the set of $p$-dimensional orthogonal basis vectors embedded in $\mathbb{R}^{n \times p}$. For $p=1$ this results in all the points on the $n$-dimensional unit sphere. The Stiefel manifold is given by:
		\begin{align}
				St(n,p) \coloneqq \{ X \in \mathbb{R}^ {n \times p} | X^T X = I_p \},
		\end{align}
		where $I_p$ is the $p$-dimension unity matrix.
	\end{block}


\end{frame}
% **************************************************************************** %

% **************************************************************************** %
\begin{frame}[t]\frametitle{Grassmann Manifold}
	\begin{block}{Grassmann Manifold}
		The Grassmann manifold $Gr(n,p)$ is a quotient manifold. Each point on the manifold denotes a $p$-dimensional subspace of $\mathbb{R}^{n}$. Anotherway to conceptualize this is to think in terms of equivalent classes $[\cdot]$: 
		\begin{align}
				[X] = [Y] \; \Leftrightarrow \; \text{span}(X) = \text{span}(Y).
		\end{align}

		Each point on the manifold is an equivalent class of $p$-dimensional bases.
		
		In numerical algorithms, elements of the Grassmann manifold are represented as elements of the Stiefel manifold. The Grassmann manifold is defined as:
		\begin{align}
				Gr(n,p) = \{[U] \ | \ U \in St(n,p)\}.
		\end{align}
	\end{block}


\end{frame}
% **************************************************************************** %

% **************************************************************************** %
\begin{frame}[t]\frametitle{Exponential and Logarithmic Maps on the Grassmann Manifold}
			\begin{block}{Exponential Map}
					Let $p_0 \in \mathcal{M} = Gr(n,p)$ and $\eta \in T_{p_0} \mathcal{M}$. Furthermore, let $ \eta = USV$ be the singular value decomposition of $\eta$, then the exponential map can be computed by:
				\begin{equation}
						\textnormal{Exp}_{p_0}^{Gr} (\eta) = p_0 V\cos(S)V^T \ + \ U\sin(S)V^T = q \in \mathcal{M},
				\end{equation}
				where $\cos$ and $\sin$ are applied to each component of $S$.

			\end{block}

			\begin{block}{Logarithmic Map}
				Let $p_0,q \in \mathcal{M} = Gr(n,p)$. The geodesic curve between $p_0$ and $q$ is given by:
				\begin{align}
						\textnormal{Log}_{p_0}^{Gr} (q) = V \arctan(S) U^T,
				\end{align}
				where the $\arctan$ is applied component-wise to $S$. $U, S$, and $V$ are from the singular value decomposition of: $USV = (q^Tp_0)^{-1}(q^T-q^Tp_0 p_0^T)$.
			\end{block}

\end{frame}
% **************************************************************************** %

% **************************************************************************** %
\begin{frame}[t]\frametitle{Exponential and Logarithmic Maps}
	\begin{figure}[H]
		\begin{center}
				\includegraphics[scale=1.5]{figs/ManifoldAndTangentSpace/ManifoldAndTangentSpace.pdf}
		\caption{This figure shows the Manifold $\mathcal{M}$ in black and the tangent space spanned at $p$ in red. The exponential map is applied on $\eta \in T_p\mathcal{M}$, which returns the element $q \in \mathcal{M}$.}
		\end{center}
\end{figure}
\end{frame}
% **************************************************************************** %



% **************************************************************************** %
\section{Interpolation on Manifolds}
\begin{frame}[c]\frametitle{Interpolation on Manifolds}

	% \centering
	\textbf{ Interpolation on Manifolds}

	\vspace*{10mm}

	\textbf{Motivation:}
	\begin{itemize}
		\item Reducing computational effort
	\end{itemize}

\end{frame}
% **************************************************************************** %

% **************************************************************************** %
\begin{frame}[t, fragile,shrink]\frametitle{Interpolation Algorithms}
	\begin{block}{Linear Splines}
		Linear splines are first degree polynomials of the form $f_i(p) = a_i p + b_i \ \forall \ p \in [p_i, p_{i+1}]$ between two data points  $v_i$ and $v_{i+1}$. Combining all the splines leads to the interpolation function $f(p)$ for the entire parameter domain $[p_1, p_k]$.
	\end{block}

	\begin{block}{Cubic Splines}
		Cubic splines are very similar to linear splines, the difference is that they use cubic polynomials of the form $f_i(p) = a_i p^3 + b_i p^2 + c_i p + d_i \ \forall p \in [p_i, p_{i+1}]$.
	\end{block}

	\begin{block}{Polynomial Interpolation}
		Polynomial interpolation works by constructing a single polynomial for the whole parameter domain. This is done with a linear combination of scaled orthogonal basis functions  $l_i(p)$.

		\begin{align*}
		f(p) = \sum_{i=0}^{n} v_i l_i(p) \ , \quad \quad l_i(p) = \prod_{\substack{0 \leq  m \leq n \\  m \neq  i}} \frac{p - p_m}{p_i -p_m}
	\end{align*}
	\end{block}

\end{frame}
% **************************************************************************** %


% **************************************************************************** %
\begin{frame}[t, fragile]\frametitle{Algorithm}
	\begin{block}{Interpolation on the Tangent Space}
		\begin{algorithm}[H]
		\caption{}
		\begin{algorithmic}[1]
			\REQUIRE Dataset $V = \{v_1, \dots, v_n\} \subset \mathcal{M}$ 
			\STATE{Chose a base point $v_i \in V$ }
			\FOR {j = 1,\dots, n}
					\STATE Compute $\textnormal{Log}_{v_i}(v_j) = w_j \in T_{v_i} \mathcal{M}$
			\ENDFOR
			\STATE Compute $w^*$ via Euclidean interpolation between $\{w_1, \dots, w_n \}$ 
			\STATE Compute $ v^* = \textnormal{Exp}_{v_i}(w^*) \in \mathcal{M}$
		\end{algorithmic}
	\end{algorithm}
\end{block}

\end{frame}
% **************************************************************************** %

% **************************************************************************** %
\begin{frame}[t]\frametitle{Algorithm}
	\includegraphics[width=.8\textwidth]{figs/ManifoldInterpolation/ManifoldInterpolation.pdf}
\end{frame}
% **************************************************************************** %


% **************************************************************************** %
\begin{frame}[t, fragile]\frametitle{Convergence}
	\begin{figure}[H]
	\begin{center}
			\resizebox{.8\textwidth}{!}{%
			\begin{tikzpicture}[]
					\pgfplotstableread[col sep = comma]{./figs/export_frobenius.csv}\mydata
					\begin{axis}[
							ymode=log,
							xmode=log,
							xlabel=Number Interpolation Nodes,
							ylabel=Error,
							title={Frobenius Norm $\|U_{\textnormal{ap}}^{} U_{\textnormal{ap}}^T - U_{\text{ex}}^{} U_{\text{ex}}^T\|_F$},
							grid=both,
							minor grid style={gray!25},
							major grid style={gray!25},
							width=1.2\linewidth,
							height = .8\linewidth,
							legend style={at={(0.03,0.2)},anchor=west},
							% legend columns=2,
							% legend to name=named,
							scale=.8
							]    
							\addplot table[x index = {0}, y index = {2}]{\mydata};
							\addlegendentry{Linear Splines}
							\addplot table[x index = {0}, y index = {3}]{\mydata};
							\addlegendentry{Cubic Splines}
							\addplot table[x index = {0}, y index = {1}]{\mydata};
							\addlegendentry{Lagrange at Chebyshev Nodes}
							\addplot table[x index = {0}, y index = {4}]{\mydata};
							\addlegendentry{Lagrange evenly spaced Grid}
					\end{axis}
			\end{tikzpicture}
		}
	\end{center}
	\end{figure}
\end{frame}
% **************************************************************************** %



% % % **************************************************************************** %
% % \begin{frame}[t]\frametitle{Eigenvalue Crossing}

% % 	\begin{figure}
% % 		\centering
% % 		\begin{subfigure}{}
% % 			\includegraphics[width=.4\textwidth]{figs/Crossing/Crossing.pdf}
% % 		\end{subfigure}%
% % 		\begin{subfigure}{}
% % 		\resizebox{.5\textwidth}{!}{%
% % 						\begin{tikzpicture}[spy using outlines= {circle, magnification=3, connect spies}]

% % 								\definecolor{color1}{HTML}{009900};
% % 								\pgfplotstableread[col sep = comma]{./figs/crossingError.csv}\dataError
% % 								\pgfplotstableread[col sep = comma]{./figs/crossingErrorInterpolationNodes.csv}\dataNodes
% % 								\pgfplotstableread[col sep = comma]{./figs/crossingErrorEigenvalues.csv}\dataEigenValues

% % 										\begin{axis}[
% % 												ylabel=$\|U_{\textnormal{ap}}^{}U_{\textnormal{ap}}^T - U_{\text{ex}}^{}U_{\text{ex}}^T\|_F$,
% % 												yticklabel style={
% % 														/pgf/number format/fixed,
% % 														/pgf/number format/precision=3
% % 														},
% % 												xticklabels={draw=none},
% % 												grid=both,
% % 												minor grid style={gray!25},
% % 												major grid style={gray!25},
% % 												width=15cm,height=5cm,
% % 												name=main plot,
% % 												line join=round,
% % 												]    
% % 												\addplot[line width=2pt, mark size=2pt] table[x index = {0}, y index = {1}]{\dataError};
% % 												\addlegendentry{Interpolation Error} 
% % 												\addplot[only marks, color = blue, mark size=2pt] table[x index = {0}, y index = {1}]{\dataNodes};
% % 												\addlegendentry{Interpolation Nodes}
% % 										\end{axis}

% % 										\begin{axis}[
% % 												xlabel=Parameter Space,
% % 												ylabel=Eigenvalues,
% % 												yticklabel style={
% % 														/pgf/number format/fixed,
% % 														/pgf/number format/precision=3
% % 														},
% % 												grid=both,
% % 												minor grid style={gray!25},
% % 												major grid style={gray!25},
% % 												width=15cm,height=7cm,
% % 												at={(main plot.below south west)},
% % 														anchor=north west,    
% % 														% yshift=-0.1ex,        
% % 												]    
% % 												\addplot[color=color1, line width=1pt, mark size=1pt, ] table[x index = {0}, y index = {1}]{\dataEigenValues};
% % 												\addplot[color=color1, line width=1pt, mark size=1pt, ] table[x index = {0}, y index = {2}]{\dataEigenValues};
% % 												\addplot[color=color1, line width=1pt, mark size=1pt, ] table[x index = {0}, y index = {3}]{\dataEigenValues};
% % 												\addplot[color=color1, line width=1pt, mark size=1pt, ] table[x index = {0}, y index = {4}]{\dataEigenValues};
% % 												\addplot[color=color1, line width=1pt, mark size=1pt, ] table[x index = {0}, y index = {5}]{\dataEigenValues};
% % 												\addplot[color=color1, line width=1pt, mark size=1pt, ] table[x index = {0}, y index = {6}]{\dataEigenValues};
% % 												\addplot[color=red, line width=1pt, mark size=1pt, ] table[x index = {0}, y index = {7}]{\dataEigenValues};
% % 												\coordinate (spypoint) at (axis cs: 0.84, 0.085);
% % 												\coordinate (magnifyglass) at (axis cs: 0.5,0.15);
% % 										\end{axis}

% % 								\spy [black, size=2.5cm] on (spypoint) in node[fill=white] at (magnifyglass);
% % 						\end{tikzpicture}
% % 						}
% % 		\end{subfigure}
% % 		\end{figure}

% % \end{frame}
% % % **************************************************************************** %

% % % **************************************************************************** %
% % \begin{frame}[t,fragile]\frametitle{Crossing Correcting Algorithm}
% % 	\begin{algorithm}[H]
% % 		\caption{Crossing Correcting Algorithm}
% % 		\begin{flushleft}
% % 				\hspace*{\algorithmicindent} \textbf{Input:}  Evaluation point $p^* \in \mathbb{R}$ \\
% % 				\hspace*{\algorithmicindent} \textbf{Require:} $n > k + s$, Interpolation function $f(p) \rightarrow \mathbb{R}^{n \times (k+s)}$, Matrix $A \in \mathbb{R}^{n \times n}$ \\ 
% % 		\end{flushleft}

% % 		\begin{algorithmic}[1]
% % 				\STATE{Evaluate $f(p^*) = w^* \in T\mathcal{M}$ and retract the result to the manifold: \par $\text{Retr}(w^*) = v^* \in \mathcal{M} \subset \mathbb{R}^{n \times (k+s)}$.}
% % 				\STATE{Project $A$ to the subspace spanned by $v^* \in \mathbb{R}^{n \times (k+s)}$: \par  $(v^*)^T A v^* = A^* \in \mathbb{R}^{(k+s) \times (k+s)}$.}
% % 				\STATE{Solve for $k+s$ eigenvalues and corresponding eigenvectors in the reduced space: \par  $A^* x_i =  \lambda_i x_i$, where $x_i \in \mathbb{R}^{k+s}$.}
% % 				\STATE{Reconstruct the eigenvectors in the full space: \par $ v^* x_i = \widetilde{x}_i \in \mathbb{R}^{n} \ \forall i \in \{1, \dots, k\}$.}
% % 		\end{algorithmic}

% % 		\begin{flushleft}
% % 				\hspace*{\algorithmicindent} \textbf{Return:}  $k$ eigenvectors $\widetilde{x}_i$ corresponding to the $k$ the smallest eigenvalues $\lambda_i$
% % 		\end{flushleft}
% % \end{algorithm}
% % \end{frame}
% % % **************************************************************************** %

% **************************************************************************** %
\begin{frame}[t,fragile]\frametitle{Graph Laplace Operator}
	\vspace*{25mm}
	\textbf{Motivation}:
	Kinetic energy of the electrons is given by the Laplace operator.
	\begin{align*}
		H = -\Delta + V
	\end{align*}
\end{frame}
% **************************************************************************** %

% **************************************************************************** %
\begin{frame}[t, fragile]\frametitle{Graphs }
	\begin{block}{Graph}
			We define a graph as pair $(\mathcal{V} , \mathcal{E})$, where $\mathcal{V} = \{V_1,...,V_n\}$ is a set of nodes and $\mathcal{E} \subseteq \mathcal{V} \times \mathcal{V}$ is a set of pairs of two vertices.
	\end{block}

	\begin{figure}[H]
			\begin{tikzpicture}
				\begin{scope}[every node/.style={circle,thick,draw}]
					\node (A) at (0,0) {A};
					\node (B) at (4,2) {B};
				\node (C) at (-3,.2) {C};
				\node (D) at (-1,1.5) {D};
			\end{scope}

			\begin{scope}[>={Stealth[black]}, every node/.style={fill=white,circle}, every edge/.style={draw=black,very thick}]
				\path [] (D) edge[bend right=10] node {$w_{B,D}$} (B);
				\path [] (B) edge[bend right=50] node {$w_{B,C}$} (C);
				\path [] (B) edge[bend left=50] node {$w_{B,A}$} (A);
				\path [] (A) edge[bend left=10] node {$w_{A,C}$} (C);
			\end{scope}

			\end{tikzpicture}    
		
		\caption{This figure shows an undirected graph with nodes $\mathcal{V} = \{A,B,C,D\}$ and edges $\mathcal{E} = \{(A,B), (A,C), (B,C), (B,D)\}$ with weights $w_{i,j}$.}
	\end{figure}
\end{frame}
% **************************************************************************** %

% **************************************************************************** %
\begin{frame}[t, fragile]\frametitle{Graphs }
	\begin{block}{Adjacency Matrix}
		The adjacency matrix $A \in \mathbb{R}^{n \times n}$ is a square matrix, whose elements indicate an edge between nodes. It is defined as:
		\begin{align*}
			A := \begin{cases}
				w_{ij}  & \text{if } e_{i,j} \in \mathcal{E}, \\
				0       & \text{else} .
			\end{cases}
		\end{align*}
	\end{block}

	\begin{block}{Degree Matrix}
		The degree matrix is a diagonal matrix. Its entries are the sums of the edge weights of the connected edges to the corresponding node. This means that in general the degree matrix can be constructed in the following way:
		\begin{align*}
			D := \begin{cases}
				\sum_{i}A_{i,j}  & \text{if } i=j, \\
				0       & \text{else} .
			\end{cases}
		\end{align*}
	\end{block}

\end{frame}
% **************************************************************************** %



% **************************************************************************** %
\begin{frame}[t]\frametitle{Graph Laplacian}
	 \begin{block}{Graph Laplacian}
		Now with the degree and weight matrix, the Laplace matrix $L$ can be constructed:
		\begin{equation}
			L = D - A .
		\end{equation}
	 \end{block}

	 \vspace*{10mm}

	 \begin{enumerate}
		\item The Laplace operator is in general the difference between the average local function and the function value at the node itself.
		\item Looks like the negative Laplace operator discretized with finite differences with free Neumann boundary conditions.
	 \end{enumerate}

\end{frame}
% **************************************************************************** %

% **************************************************************************** %
\begin{frame}[t]\frametitle{Properties Eigenfunctions Graph Laplacian}
	\begin{center}
		\textbf{Use Case Laplace Eigenfunctions}
		\begin{itemize}
			\centering
			\item Graph partitioning
			\item Spectral clustering
		\end{itemize}
	\end{center}

	\begin{figure}[H]
		\centering
		\includegraphics[width=1\textwidth]{figs/eigenfunctions_interpretation.png}
	\end{figure}

\end{frame}
% **************************************************************************** %

% **************************************************************************** %
\begin{frame}[t]\frametitle{Animating Meshes}
	\begin{figure}[H]
		\centering
			\resizebox{\textwidth}{!}{%
			\begin{tikzpicture}
				\node[inner sep=0pt,scale=.21] (T1) at (0,-0.2) {\includegraphics[width=1\textwidth]{figs/SpiderManRender/t=0.png}};
				% \node[inner sep=0pt,scale=.2] (T2) at (-2.5,0) {\includegraphics[width=1\textwidth]{figs/SpiderManRender/t=2.png}};
				\node[inner sep=0pt,scale=.19] (T3) at (3,0) {\includegraphics[width=1\textwidth]{figs/SpiderManRender/t=4.png}};
				\node[inner sep=0pt,scale=.20] (T4) at (6,0.3) {\includegraphics[width=1\textwidth]{figs/SpiderManRender/t=6.png}};
				\node[inner sep=0pt,scale=.21] (T5) at (9,0.6) {\includegraphics[width=1\textwidth]{figs/SpiderManRender/t=8.png}};
				\node[inner sep=0pt,scale=.23] (T6) at (12,0.7) {\includegraphics[width=1\textwidth]{figs/SpiderManRender/t=10.png}};
		
				\draw[-stealth,line width= 1.5pt] (0,-3) to (12,-3);
				\draw (5.5,-2.5) node[] {Time};
			\end{tikzpicture}
			}
	\end{figure}
\end{frame}
% **************************************************************************** %

% **************************************************************************** %
\begin{frame}[t]\frametitle{Animating Meshes}
	\begin{figure}[H]
		\centering
			\begin{tikzpicture}[spy using outlines= {circle, magnification=3, connect spies}]
				\node[inner sep=0pt] (tmp) at (0,0) {\includegraphics[scale=0.15]{figs/mesh_view.png}};
				\coordinate (spypoint) at (-2.9, -0.15);
				\coordinate (magnifyglass) at (-7,2.5);
				\spy [black, size=5cm] on (spypoint) in node[fill=white] at (magnifyglass);
			\end{tikzpicture}
		\caption{This figure shows the used mesh. The mesh is made up of 11027 vertices and 22112 edges. In the close-up view, the edges and nodes from which the mesh is constructed are clearly visible.}
		\label{fig:meshView}
	\end{figure}
\end{frame}
% **************************************************************************** %



% **************************************************************************** %
\begin{frame}[t]\frametitle{Result}
	\begin{figure}[H]
		\centering
		\resizebox{\textwidth}{!}{%
		\begin{tikzpicture}
			% SPIDER PLOT
			\node[inner sep=0pt,scale=1] (T1) at (0,0) {\includegraphics[width=1\textwidth]{figs/5th_eigenfunction-.png}};

			% ERROR PLOT
			\pgfplotstableread[col sep = comma]{./figs/errorSpiderPlot.csv}\mydata
			\begin{axis}[
				xlabel={time point},
				ylabel={$\|U_{\textnormal{ap}}^{} U_{\textnormal{ap}}^T - U_{\text{ex}}^{} U_{\text{ex}}^T\|_F$},
				grid=both,
				minor grid style={gray!25},
				major grid style={gray!25},
				width=1.05\linewidth,
				height=3cm,
				at={(-0.5\linewidth,-4cm)}
				]    
				\addplot table[x index = {0}, y index = {1}]{\mydata};
			\end{axis}
		\end{tikzpicture}
		}
	\end{figure}
\end{frame}
% **************************************************************************** %



% % % **************************************************************************** %
% % \section{Energy Based Interpolation}
% % \begin{frame}[t]\frametitle{Result}
% % 	\begin{problem}[Energy Based Interpolation]~\\ \label{pr:EnergyBasedInterpolation}
% % 		Find the curve $\gamma_{opt}(t) \in St(n,p)$, such that the following integral is minimized:
% % 		\begin{align*}
% % 		\gamma_{opt}(t) &= \argmin \int_{t_{start}}^{t_{end}} \frac{\gamma(t)^T A(t) \gamma(t)}{ \gamma(t)^T \gamma(t)} dt \\
% % 			\text{subject to}:&  \\
% % 			& \gamma(t)^T\gamma(t) = \text{I} \quad \forall t \in [t_{\text{start}},t_{\text{end}}], \\
% % 			& \gamma(t_{start}) = \gamma_{start}, \\
% % 			& \gamma(t_{end}) = \gamma_{end}.
% % 		\end{align*}
% % 	\end{problem}
% % \end{frame}
% % % **************************************************************************** %

% % % **************************************************************************** %
% % \begin{frame}[t]\frametitle{Result}


% % 	\begin{align}
% % 		\gamma_{opt}(t) &= \argmin \int_{t_{start}}^{t_{end}} \frac{\gamma(t)^T A(t) \gamma(t)}{ \gamma(t)^T \gamma(t)} dt \\
% % 	\end{align}

% % 	\vspace*{5mm}

% % 	Euler-Lagrange equation:
% % 	\begin{align}
% % 		\frac{\partial F}{\partial y} - \frac{\text{d}}{\text{d}x} \frac{\partial F}{\partial y'} = 0
% % 	\end{align}

% % 	\vspace*{5mm}

% % 	This leads to:
% % 	\begin{align}
% %  	   \frac{2}{\| \gamma \|^2} \left(A(t) -  \frac{\gamma(t)^T A(t) \gamma(t)}{ \gamma(t)^T \gamma(t)} \right) \gamma(t) = 0
% % 	\end{align}

% % \end{frame}
% % % **************************************************************************** %

% % % **************************************************************************** %
% % \begin{frame}[t]\frametitle{Result}


% % 	\begin{align}
% %  	   \int_{t_{start}}^{t_{end}} \frac{\gamma(t)^T A(t) \gamma(t)}{ \gamma(t)^T \gamma(t)} dt \ \approx \ \sum_{i=1}^N \frac{\gamma_i^T A_i \gamma_i}{ \gamma_i^T \gamma_i} \Delta t
% % 	\end{align}
% % 	\begin{align}
% %     	\frac{\partial F}{\partial \gamma_i} =  \frac{2 \Delta t}{\| \gamma \|^2}  \left(A_i -  \frac{\gamma_i^T A_i \gamma_i}{ \gamma_i^T \gamma_i} \right) \gamma_i = 0
% % 	\end{align}

% % 	\begin{figure}[H]
% % 		\begin{center}
% % 			\includegraphics[scale=1]{figs/HierarchicalInterpolation/ErrorInterpolation.pdf}
% % 		\end{center}
% % 	\end{figure}
% % \end{frame}
% % % **************************************************************************** %
